/*
 * Copyright 2010 by Kappich Systemberatung Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.pua.prot.data;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.AttributeType;

import java.util.Collections;
import java.util.List;

/**
 * @author Kappich Systemberatung
 * @version $Revision: 0000 $
 */
public class ArrayProtocolData extends ProtocolData {

	private List<Data> _childrenList;

	public ArrayProtocolData(final List<Data> childrenList) {
		_childrenList = childrenList;
	}

	@Override
	public boolean isError() {
		return false;
	}

	@Override
	protected List<Data> getChildrenList() {
		return Collections.unmodifiableList(_childrenList);
	}

	public Data createUnmodifiableCopy() {
		throw new UnsupportedOperationException("Kopie erstellen nicht möglich.");
	}

	public String getName() {
		return null;
	}

	public AttributeType getAttributeType() {
		return null;
	}

	public boolean isDefined() {
		return true;
	}

	@Override
	public boolean isNoChange() {
		return false;
	}

	public boolean isList() {
		return false;
	}

	public boolean isArray() {
		return true;
	}

	public boolean isPlain() {
		return false;
	}

	public Data getItem(final String itemName) {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_LIST);
	}

	public TextValue asTextValue() {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_ATOMAR);
	}

	public TimeValue asTimeValue() {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_ATOMAR);
	}

	public NumberValue asScaledValue() {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_ATOMAR);
	}

	public NumberValue asUnscaledValue() {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_ATOMAR);
	}

	public ReferenceValue asReferenceValue() {
		throw new UnsupportedOperationException(getName() + MESSAGE_NOT_ATOMAR);
	}

	public Array asArray() {
		return new ArrayDataArrayView(this);
	}

	public TextArray asTextArray() {
		return new ArrayDataArrayView(this);
	}

	public TimeArray asTimeArray() {
		return new ArrayDataArrayView(this);
	}

	public NumberArray asScaledArray() {
		return new ArrayDataArrayView(this);
	}

	public NumberArray asUnscaledArray() {
		return new ArrayDataArrayView.UnscaledArrayDataArrayView(this);
	}

	public ReferenceArray asReferenceArray() {
		return new ArrayDataArrayView(this);
	}
}
