// $ANTLR 2.7.7 (2006-11-01): "grammar.g" -> "ProtocolTreeWalker.java"$

/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */
	package de.bsvrz.pua.prot.interpreter;

	import java.io.*;
	import java.awt.event.*;
	import antlr.*;
	import antlr.debug.misc.*;

	import java.util.ArrayList;
	import java.util.HashSet;
	import java.util.List;
	import de.bsvrz.pua.prot.util.ExpressionTree;
	import de.bsvrz.pua.prot.util.ExpressionLeaf;
	import de.bsvrz.pua.prot.exceptions.CriticalParserException;
	import de.bsvrz.pua.prot.exceptions.SemanticErrorException;
	import de.bsvrz.pua.prot.util.ProcessingInformation;
	import de.bsvrz.pua.prot.util.ProcessingParameter;
	import de.bsvrz.sys.funclib.losb.datk.ProtocolType;
	import de.bsvrz.sys.funclib.losb.datk.NoChangeMarker;
	import de.bsvrz.pua.prot.util.attributes.DurationAttributeDescription;

	import de.bsvrz.pua.prot.interpreter.semantics.Semantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AggregationSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AttributeGroupSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.ExpressionSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.MiscellaneousSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.RealAttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.ScopeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.TempAttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.SymbolTable;

	import de.bsvrz.dav.daf.main.config.DataModel;


import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


/**
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $$Revision: 1.9 $$ / $$Date: 2007/12/17 15:22:59 $$ / ($$Author: martinh $$)
 */
public class ProtocolTreeWalker extends antlr.TreeParser       implements ProtocolTokensTokenTypes
 {

	//Zum überprüfen der Semantik
	private Semantics _semantics;
	private AggregationSemantics _aggregationSemantics;
	private AttributeGroupSemantics _attributeGroupSemantics;
	private AttributeSemantics _attributeSemantics;
	private ExpressionSemantics _expressionSemantics;
	private MiscellaneousSemantics _miscSemantics;
	private RealAttributeSemantics _realAttributeSemantics;
	private ScopeSemantics _scopeSemantics;
	private TempAttributeSemantics _tempAttributeSemantics;

	//Freie Bindungen sollen gebunden werden
	private boolean _noFreeAspects = false;

	public ProtocolTreeWalker(Semantics semantics)
	{
		super();
		this._semantics = semantics;
		_aggregationSemantics = _semantics.getAggregationSemantics();
		_attributeGroupSemantics = _semantics.getAttributeGroupSemantics();
		_attributeSemantics = _semantics.getAttributeSemantics();
		_expressionSemantics = _semantics.getExpressionSemantics();
		_miscSemantics = _semantics.getMiscSemantics();
		_realAttributeSemantics = _semantics.getRealAttributeSemantics();
		_scopeSemantics = _semantics.getScopeSemantics();
		_tempAttributeSemantics = _semantics.getTempAttributeSemantics();
	}
public ProtocolTreeWalker() {
	tokenNames = _tokenNames;
}

	public final void skript(AST _t) throws RecognitionException {
		
		AST skript_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		{
		_loop228:
		do {
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Spalten:
			{
				spaltenDefinition(_t);
				_t = _retTree;
				break;
			}
			case Filter:
			{
				filterDefinition(_t);
				_t = _retTree;
				break;
			}
			case Standards:
			{
				standardsListe(_t);
				_t = _retTree;
				break;
			}
			case Definitionen:
			{
				definitionenListe(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				break _loop228;
			}
			}
		} while (true);
		}
		_retTree = _t;
	}
	
	public final void spaltenDefinition(AST _t) throws RecognitionException {
		
		AST spaltenDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t230 = _t;
		AST tmp1_AST_in = (AST)_t;
		match(_t,Spalten);
		_t = _t.getFirstChild();
		spaltenMitBlock(_t);
		_t = _retTree;
		_t = __t230;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void filterDefinition(AST _t) throws RecognitionException {
		
		AST filterDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t261 = _t;
		AST tmp2_AST_in = (AST)_t;
		match(_t,Filter);
		_t = _t.getFirstChild();
		filterMitBlock(_t);
		_t = _retTree;
		_t = __t261;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void standardsListe(AST _t) throws RecognitionException {
		
		AST standardsListe_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t297 = _t;
		AST tmp3_AST_in = (AST)_t;
		match(_t,Standards);
		_t = _t.getFirstChild();
		standardsMitBlock(_t);
		_t = _retTree;
		_t = __t297;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void definitionenListe(AST _t) throws RecognitionException {
		
		AST definitionenListe_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t324 = _t;
		AST tmp4_AST_in = (AST)_t;
		match(_t,Definitionen);
		_t = _t.getFirstChild();
		definitionenMitBlock(_t);
		_t = _retTree;
		_t = __t324;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void spaltenMitBlock(AST _t) throws RecognitionException {
		
		AST spaltenMitBlock_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		{
		_loop233:
		do {
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Mit:
			{
				mitKonstruktSpalte(_t);
				_t = _retTree;
				break;
			}
			case Attribut:
			case Zeitdauer:
			{
				attributSpalte(_t);
				_t = _retTree;
				break;
			}
			case TempAttribut:
			{
				tempAttributSpalte(_t);
				_t = _retTree;
				break;
			}
			case Attributgruppe:
			{
				attributgruppenSpalte(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				break _loop233;
			}
			}
		} while (true);
		}
		_retTree = _t;
	}
	
	public final void mitKonstruktSpalte(AST _t) throws RecognitionException {
		
		AST mitKonstruktSpalte_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST P = null;
		
				List<String> path = null;
			
		
		AST __t235 = _t;
		AST tmp5_AST_in = (AST)_t;
		match(_t,Mit);
		_t = _t.getFirstChild();
		P = _t==ASTNULL ? null : (AST)_t;
		path=qualifizierung(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.push(P,path);
		}
		spaltenMitBlock(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.pop();
		}
		_t = __t235;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void attributSpalte(AST _t) throws RecognitionException {
		
		AST attributSpalte_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST f1 = null;
		AST ast = null;
		
				ArrayList<String> v = new ArrayList<>();
				String alsName = null, y = null;
			
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Attribut:
		{
			AST __t241 = _t;
			AST tmp6_AST_in = (AST)_t;
			match(_t,Attribut);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case NichtAuffuellenA:
			case NichtAuffuellenB:
			{
				f1 = _t==ASTNULL ? null : (AST)_t;
				nichtAuffuellen(_t);
				_t = _retTree;
				break;
			}
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			ast = _t==ASTNULL ? null : (AST)_t;
			attributAngabe(_t,v);
			_t = _retTree;
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Als:
			{
				alsName=alsDefinition(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t241;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_realAttributeSemantics.addRealAttribute(ast, v, alsName, (f1==null));
			}
			break;
		}
		case Zeitdauer:
		{
			AST __t244 = _t;
			AST tmp7_AST_in = (AST)_t;
			match(_t,Zeitdauer);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Als:
			{
				alsDefinition(_t);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t244;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.addDurationAttribute();
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void tempAttributSpalte(AST _t) throws RecognitionException {
		
		AST tempAttributSpalte_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST n = null;
		
				String alsName = null;
			
		
		AST __t252 = _t;
		AST tmp8_AST_in = (AST)_t;
		match(_t,TempAttribut);
		_t = _t.getFirstChild();
		n = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Als:
		{
			alsName=alsDefinition(_t);
			_t = _retTree;
			break;
		}
		case 3:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		_t = __t252;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			_tempAttributeSemantics.addTempAttributePlaceholder(n.getText(), alsName);
		}
		_retTree = _t;
	}
	
	public final void attributgruppenSpalte(AST _t) throws RecognitionException {
		
		AST attributgruppenSpalte_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST a = null;
		AST na = null;
		
				ArrayList<String> v = new ArrayList<>();
				String alsName = null;
			
		
		AST __t255 = _t;
		a = _t==ASTNULL ? null :(AST)_t;
		match(_t,Attributgruppe);
		_t = _t.getFirstChild();
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case NichtAuffuellenA:
		case NichtAuffuellenB:
		{
			na = _t==ASTNULL ? null : (AST)_t;
			nichtAuffuellen(_t);
			_t = _retTree;
			break;
		}
		case Name:
		case NameMitKlammern:
		case Fragezeichen:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		{
		int _cnt258=0;
		_loop258:
		do {
			if (_t==null) _t=ASTNULL;
			if (((_t.getType() >= Name && _t.getType() <= Fragezeichen))) {
				aspektName(_t,v);
				_t = _retTree;
			}
			else {
				if ( _cnt258>=1 ) { break _loop258; } else {throw new NoViableAltException(_t);}
			}
			
			_cnt258++;
		} while (true);
		}
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Als:
		{
			alsName=alsDefinition(_t);
			_t = _retTree;
			break;
		}
		case 3:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		_t = __t255;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			_attributeGroupSemantics.addAttributeGroup(a, v, alsName, (na==null));
		}
		_retTree = _t;
	}
	
	public final List<String>  qualifizierung(AST _t) throws RecognitionException {
		List<String> path = new ArrayList<String>();
		
		AST qualifizierung_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST o = null;
		AST a = null;
		
		AST __t237 = _t;
		o = _t==ASTNULL ? null :(AST)_t;
		match(_t,Name);
		_t = _t.getFirstChild();
		if ( inputState.guessing==0 ) {
			path.add(o.getText());
		}
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Name:
		{
			a = (AST)_t;
			match(_t,Name);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				path.add(a.getText());
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			{
				aspektName(_t,path);
				_t = _retTree;
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			break;
		}
		case 3:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		_t = __t237;
		_t = _t.getNextSibling();
		_retTree = _t;
		return path;
	}
	
	public final void aspektName(AST _t,
		List v
	) throws RecognitionException {
		
		AST aspektName_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST n = null;
		AST n2 = null;
		AST f = null;
		AST z = null;
		if (v == null) v = new ArrayList();
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Name:
		case NameMitKlammern:
		{
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Name:
			{
				n = (AST)_t;
				match(_t,Name);
				_t = _t.getNextSibling();
				break;
			}
			case NameMitKlammern:
			{
				n2 = (AST)_t;
				match(_t,NameMitKlammern);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			if ( inputState.guessing==0 ) {
				v.add(n != null? n.getText() : n2.getText());
			}
			break;
		}
		case Fragezeichen:
		{
			AST __t250 = _t;
			f = _t==ASTNULL ? null :(AST)_t;
			match(_t,Fragezeichen);
			_t = _t.getFirstChild();
			z = (AST)_t;
			match(_t,GanzZahl);
			_t = _t.getNextSibling();
			_t = __t250;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				
															String aspect = _miscSemantics.getBinding(f.getText()+z.getText());
															v.add(aspect);
														
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void nichtAuffuellen(AST _t) throws RecognitionException {
		
		AST nichtAuffuellen_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case NichtAuffuellenA:
		{
			AST tmp9_AST_in = (AST)_t;
			match(_t,NichtAuffuellenA);
			_t = _t.getNextSibling();
			break;
		}
		case NichtAuffuellenB:
		{
			AST tmp10_AST_in = (AST)_t;
			match(_t,NichtAuffuellenB);
			_t = _t.getNextSibling();
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void attributAngabe(AST _t,
		List v
	) throws RecognitionException {
		
		AST attributAngabe_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		aspektName(_t,v);
		_t = _retTree;
		{
		_loop372:
		do {
			if (_t==null) _t=ASTNULL;
			if ((_t.getType()==Doppelpunkt)) {
				AST tmp11_AST_in = (AST)_t;
				match(_t,Doppelpunkt);
				_t = _t.getNextSibling();
				{
				aspektName(_t,v);
				_t = _retTree;
				}
			}
			else {
				break _loop372;
			}
			
		} while (true);
		}
		_retTree = _t;
	}
	
	public final String  alsDefinition(AST _t) throws RecognitionException {
		String s = null;
		
		AST alsDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST n = null;
		
		AST __t247 = _t;
		AST tmp12_AST_in = (AST)_t;
		match(_t,Als);
		_t = _t.getFirstChild();
		n = (AST)_t;
		match(_t,Zeichenkette);
		_t = _t.getNextSibling();
		_t = __t247;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			
					s = n.getText().substring(1,n.getText().length()-1);
				
		}
		_retTree = _t;
		return s;
	}
	
	public final void filterMitBlock(AST _t) throws RecognitionException {
		
		AST filterMitBlock_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		{
		_loop264:
		do {
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Mit:
			{
				mitKonstruktFilter(_t);
				_t = _retTree;
				break;
			}
			case Zeitdauer:
			case Aggregation:
			{
				aggregationsBlock(_t);
				_t = _retTree;
				break;
			}
			case Einschraenkung:
			case EinschraenkungUml:
			{
				einschraenkungsAnweisung(_t);
				_t = _retTree;
				break;
			}
			case Anwendung:
			{
				anwendungsAnweisung(_t);
				_t = _retTree;
				break;
			}
			case Nachfilter:
			{
				nachFilterAnweisung(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				break _loop264;
			}
			}
		} while (true);
		}
		_retTree = _t;
	}
	
	public final void mitKonstruktFilter(AST _t) throws RecognitionException {
		
		AST mitKonstruktFilter_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST P = null;
		
				List<String> path = null;
			
		
		AST __t266 = _t;
		AST tmp13_AST_in = (AST)_t;
		match(_t,Mit);
		_t = _t.getFirstChild();
		P = _t==ASTNULL ? null : (AST)_t;
		path=qualifizierung(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.push(P, path);
		}
		filterMitBlock(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.pop();
		}
		_t = __t266;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void aggregationsBlock(AST _t) throws RecognitionException {
		
		AST aggregationsBlock_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST az = null;
		AST a = null;
		AST na = null;
		
				ArrayList<String> attrList = new ArrayList<String>();
				ArrayList<String> aggrList = new ArrayList<String>();
			
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Zeitdauer:
		{
			AST __t268 = _t;
			az = _t==ASTNULL ? null :(AST)_t;
			match(_t,Zeitdauer);
			_t = _t.getFirstChild();
			aspektName(_t,aggrList);
			_t = _retTree;
			{
			_loop270:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==Komma)) {
					AST tmp14_AST_in = (AST)_t;
					match(_t,Komma);
					_t = _t.getNextSibling();
					aspektName(_t,aggrList);
					_t = _retTree;
				}
				else {
					break _loop270;
				}
				
			} while (true);
			}
			_t = __t268;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_aggregationSemantics.addAggregationForDuration(az, aggrList);
			}
			break;
		}
		case Aggregation:
		{
			AST __t271 = _t;
			a = _t==ASTNULL ? null :(AST)_t;
			match(_t,Aggregation);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case NichtAuffuellenA:
			case NichtAuffuellenB:
			{
				na = _t==ASTNULL ? null : (AST)_t;
				nichtAuffuellen(_t);
				_t = _retTree;
				break;
			}
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			int _cnt274=0;
			_loop274:
			do {
				if (_t==null) _t=ASTNULL;
				if (((_t.getType() >= Name && _t.getType() <= Fragezeichen))) {
					aspektName(_t,attrList);
					_t = _retTree;
				}
				else {
					if ( _cnt274>=1 ) { break _loop274; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt274++;
			} while (true);
			}
			AST tmp15_AST_in = (AST)_t;
			match(_t,Doppelpunkt);
			_t = _t.getNextSibling();
			aspektName(_t,aggrList);
			_t = _retTree;
			{
			_loop276:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==Komma)) {
					AST tmp16_AST_in = (AST)_t;
					match(_t,Komma);
					_t = _t.getNextSibling();
					aspektName(_t,aggrList);
					_t = _retTree;
				}
				else {
					break _loop276;
				}
				
			} while (true);
			}
			_t = __t271;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_aggregationSemantics.addAggregation(a, attrList, aggrList, (na==null));
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void einschraenkungsAnweisung(AST _t) throws RecognitionException {
		
		AST einschraenkungsAnweisung_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				ExpressionTree tree = null;
				boolean merge = false;
			
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Einschraenkung:
		{
			AST __t278 = _t;
			AST tmp17_AST_in = (AST)_t;
			match(_t,Einschraenkung);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Verschmelzen:
			{
				AST tmp18_AST_in = (AST)_t;
				match(_t,Verschmelzen);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					merge = true;
				}
				break;
			}
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			case GanzZahl:
			case Zeitdauer:
			case Zeichenkette:
			case Minus:
			case Gleich:
			case Oder:
			case Und:
			case Ungleich:
			case Kleiner:
			case Groesser:
			case KleinerGleich:
			case GroesserGleich:
			case Plus:
			case Ampersand:
			case Mal:
			case Dividiert:
			case Div:
			case Modulo:
			case Nicht:
			case KommaZahl:
			case EckigeKlammerAuf:
			case Potenz:
			case Exp:
			case Ln:
			case Min:
			case Max:
			case Abs:
			case IstFehler:
			case IstZahl:
			case IstZustand:
			case IstLeer:
			case IstText:
			case IstWahrheitswert:
			case Falsch:
			case Wahr:
			case NichtAuffuellenA:
			case NichtAuffuellenB:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			tree=ausdruck(_t,false);
			_t = _retTree;
			_t = __t278;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setConstraint(tree, merge);
			}
			break;
		}
		case EinschraenkungUml:
		{
			AST __t280 = _t;
			AST tmp19_AST_in = (AST)_t;
			match(_t,EinschraenkungUml);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Verschmelzen:
			{
				AST tmp20_AST_in = (AST)_t;
				match(_t,Verschmelzen);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					merge = true;
				}
				break;
			}
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			case GanzZahl:
			case Zeitdauer:
			case Zeichenkette:
			case Minus:
			case Gleich:
			case Oder:
			case Und:
			case Ungleich:
			case Kleiner:
			case Groesser:
			case KleinerGleich:
			case GroesserGleich:
			case Plus:
			case Ampersand:
			case Mal:
			case Dividiert:
			case Div:
			case Modulo:
			case Nicht:
			case KommaZahl:
			case EckigeKlammerAuf:
			case Potenz:
			case Exp:
			case Ln:
			case Min:
			case Max:
			case Abs:
			case IstFehler:
			case IstZahl:
			case IstZustand:
			case IstLeer:
			case IstText:
			case IstWahrheitswert:
			case Falsch:
			case Wahr:
			case NichtAuffuellenA:
			case NichtAuffuellenB:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			tree=ausdruck(_t,false);
			_t = _retTree;
			_t = __t280;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setConstraint(tree, merge);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void anwendungsAnweisung(AST _t) throws RecognitionException {
		
		AST anwendungsAnweisung_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				HashSet<ProcessingInformation.ApplyAggregation> aggregationList = new HashSet<ProcessingInformation.ApplyAggregation>();
				ProcessingInformation.ApplyAggregation agg = null;
			
		
		AST __t283 = _t;
		AST tmp21_AST_in = (AST)_t;
		match(_t,Anwendung);
		_t = _t.getFirstChild();
		{
		int _cnt285=0;
		_loop285:
		do {
			if (_t==null) _t=ASTNULL;
			if ((_t.getType()==Gesamt||_t.getType()==Intervall||_t.getType()==Liste)) {
				agg=anwendungsArt(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					aggregationList.add(agg);
				}
			}
			else {
				if ( _cnt285>=1 ) { break _loop285; } else {throw new NoViableAltException(_t);}
			}
			
			_cnt285++;
		} while (true);
		}
		_t = __t283;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			_aggregationSemantics.setOrder(aggregationList);
		}
		_retTree = _t;
	}
	
	public final void nachFilterAnweisung(AST _t) throws RecognitionException {
		
		AST nachFilterAnweisung_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST z = null;
		
		AST __t295 = _t;
		AST tmp22_AST_in = (AST)_t;
		match(_t,Nachfilter);
		_t = _t.getFirstChild();
		z = (AST)_t;
		match(_t,Zeichenkette);
		_t = _t.getNextSibling();
		_t = __t295;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			_miscSemantics.setPostFilter(z, z.getText().substring(1, z.getText().length()-1));
		}
		_retTree = _t;
	}
	
	public final ExpressionTree  ausdruck(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionTree tree = new ExpressionTree();
		
		AST ausdruck_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST n = null;
		AST m = null;
		ExpressionTree left, right;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Oder:
		{
			AST __t337 = _t;
			AST tmp23_AST_in = (AST)_t;
			match(_t,Oder);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t337;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.or;tree.left = left; tree.right = right;
			}
			break;
		}
		case Und:
		{
			AST __t338 = _t;
			AST tmp24_AST_in = (AST)_t;
			match(_t,Und);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t338;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.and;tree.left = left; tree.right = right;
			}
			break;
		}
		case Gleich:
		{
			AST __t339 = _t;
			AST tmp25_AST_in = (AST)_t;
			match(_t,Gleich);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t339;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.equal;tree.left = left; tree.right = right;
			}
			break;
		}
		case Ungleich:
		{
			AST __t340 = _t;
			AST tmp26_AST_in = (AST)_t;
			match(_t,Ungleich);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t340;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.notEqual;tree.left = left; tree.right = right;
			}
			break;
		}
		case Kleiner:
		{
			AST __t341 = _t;
			AST tmp27_AST_in = (AST)_t;
			match(_t,Kleiner);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t341;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.less;tree.left = left; tree.right = right;
			}
			break;
		}
		case Groesser:
		{
			AST __t342 = _t;
			AST tmp28_AST_in = (AST)_t;
			match(_t,Groesser);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t342;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.greater;tree.left = left; tree.right = right;
			}
			break;
		}
		case KleinerGleich:
		{
			AST __t343 = _t;
			AST tmp29_AST_in = (AST)_t;
			match(_t,KleinerGleich);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t343;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.lessEqual;tree.left = left; tree.right = right;
			}
			break;
		}
		case GroesserGleich:
		{
			AST __t344 = _t;
			AST tmp30_AST_in = (AST)_t;
			match(_t,GroesserGleich);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t344;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.greaterEqual;tree.left = left; tree.right = right;
			}
			break;
		}
		case Plus:
		{
			AST __t345 = _t;
			AST tmp31_AST_in = (AST)_t;
			match(_t,Plus);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t345;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.add;tree.left = left; tree.right = right;
			}
			break;
		}
		case Ampersand:
		{
			AST __t350 = _t;
			AST tmp32_AST_in = (AST)_t;
			match(_t,Ampersand);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t350;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.conc;tree.left = left; tree.right = right;
			}
			break;
		}
		case Mal:
		{
			AST __t351 = _t;
			AST tmp33_AST_in = (AST)_t;
			match(_t,Mal);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t351;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.mult;tree.left = left; tree.right = right;
			}
			break;
		}
		case Dividiert:
		{
			AST __t352 = _t;
			AST tmp34_AST_in = (AST)_t;
			match(_t,Dividiert);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t352;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.div;tree.left = left; tree.right = right;
			}
			break;
		}
		case Div:
		{
			AST __t353 = _t;
			AST tmp35_AST_in = (AST)_t;
			match(_t,Div);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t353;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.divInt;tree.left = left; tree.right = right;
			}
			break;
		}
		case Modulo:
		{
			AST __t354 = _t;
			AST tmp36_AST_in = (AST)_t;
			match(_t,Modulo);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			right=ausdruck(_t,b);
			_t = _retTree;
			_t = __t354;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.modulo;tree.left = left; tree.right = right;
			}
			break;
		}
		case Nicht:
		{
			AST __t364 = _t;
			AST tmp37_AST_in = (AST)_t;
			match(_t,Nicht);
			_t = _t.getFirstChild();
			left=ausdruck(_t,b);
			_t = _retTree;
			_t = __t364;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				tree.operation = ExpressionTree.Operation.not;tree.left = left;
			}
			break;
		}
		case Name:
		case NameMitKlammern:
		case Fragezeichen:
		case GanzZahl:
		case Zeitdauer:
		case Zeichenkette:
		case KommaZahl:
		case EckigeKlammerAuf:
		case Potenz:
		case Exp:
		case Ln:
		case Min:
		case Max:
		case Abs:
		case IstFehler:
		case IstZahl:
		case IstZustand:
		case IstLeer:
		case IstText:
		case IstWahrheitswert:
		case Falsch:
		case Wahr:
		case NichtAuffuellenA:
		case NichtAuffuellenB:
		{
			left=erweiterterAusdruck(_t,b);
			_t = _retTree;
			if ( inputState.guessing==0 ) {
				tree = left;
			}
			break;
		}
		default:
			boolean synPredMatched348 = false;
			if (_t==null) _t=ASTNULL;
			if (((_t.getType()==Minus))) {
				AST __t348 = _t;
				synPredMatched348 = true;
				inputState.guessing++;
				try {
					{
					AST __t347 = _t;
					AST tmp38_AST_in = (AST)_t;
					match(_t,Minus);
					_t = _t.getFirstChild();
					ausdruck(_t,b);
					_t = _retTree;
					ausdruck(_t,b);
					_t = _retTree;
					_t = __t347;
					_t = _t.getNextSibling();
					}
				}
				catch (RecognitionException pe) {
					synPredMatched348 = false;
				}
				_t = __t348;
inputState.guessing--;
			}
			if ( synPredMatched348 ) {
				AST __t349 = _t;
				AST tmp39_AST_in = (AST)_t;
				match(_t,Minus);
				_t = _t.getFirstChild();
				left=ausdruck(_t,b);
				_t = _retTree;
				right=ausdruck(_t,b);
				_t = _retTree;
				_t = __t349;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					tree.operation = ExpressionTree.Operation.subtract;tree.left = left; tree.right = right;
				}
			}
			else {
				boolean synPredMatched357 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==Minus))) {
					AST __t357 = _t;
					synPredMatched357 = true;
					inputState.guessing++;
					try {
						{
						AST __t356 = _t;
						AST tmp40_AST_in = (AST)_t;
						match(_t,Minus);
						_t = _t.getFirstChild();
						AST tmp41_AST_in = (AST)_t;
						match(_t,GanzZahl);
						_t = _t.getNextSibling();
						_t = __t356;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched357 = false;
					}
					_t = __t357;
inputState.guessing--;
				}
				if ( synPredMatched357 ) {
					AST __t358 = _t;
					AST tmp42_AST_in = (AST)_t;
					match(_t,Minus);
					_t = _t.getFirstChild();
					n = (AST)_t;
					match(_t,GanzZahl);
					_t = _t.getNextSibling();
					_t = __t358;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						tree = ExpressionLeaf.createLongLeaf(n, "-" + n.getText());
					}
				}
				else {
					boolean synPredMatched361 = false;
					if (_t==null) _t=ASTNULL;
					if (((_t.getType()==Minus))) {
						AST __t361 = _t;
						synPredMatched361 = true;
						inputState.guessing++;
						try {
							{
							AST __t360 = _t;
							AST tmp43_AST_in = (AST)_t;
							match(_t,Minus);
							_t = _t.getFirstChild();
							AST tmp44_AST_in = (AST)_t;
							match(_t,KommaZahl);
							_t = _t.getNextSibling();
							_t = __t360;
							_t = _t.getNextSibling();
							}
						}
						catch (RecognitionException pe) {
							synPredMatched361 = false;
						}
						_t = __t361;
inputState.guessing--;
					}
					if ( synPredMatched361 ) {
						AST __t362 = _t;
						AST tmp45_AST_in = (AST)_t;
						match(_t,Minus);
						_t = _t.getFirstChild();
						m = (AST)_t;
						match(_t,KommaZahl);
						_t = _t.getNextSibling();
						_t = __t362;
						_t = _t.getNextSibling();
						if ( inputState.guessing==0 ) {
							tree = ExpressionLeaf.createDoubleLeaf(m, "-" + m.getText());
						}
					}
					else if ((_t.getType()==Minus)) {
						AST __t363 = _t;
						AST tmp46_AST_in = (AST)_t;
						match(_t,Minus);
						_t = _t.getFirstChild();
						left=ausdruck(_t,b);
						_t = _retTree;
						_t = __t363;
						_t = _t.getNextSibling();
						if ( inputState.guessing==0 ) {
							tree.operation = ExpressionTree.Operation.neg;tree.left = left;
						}
					}
				else {
					throw new NoViableAltException(_t);
				}
				}}}
				_retTree = _t;
				return tree;
			}
			
	public final ProcessingInformation.ApplyAggregation  anwendungsArt(AST _t) throws RecognitionException {
		ProcessingInformation.ApplyAggregation agg = ProcessingInformation.ApplyAggregation.LISTE;
		
		AST anwendungsArt_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Gesamt:
		{
			AST __t287 = _t;
			AST tmp47_AST_in = (AST)_t;
			match(_t,Gesamt);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				agg = ProcessingInformation.ApplyAggregation.GESAMT_SPALTE;
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Objekt:
			{
				AST tmp48_AST_in = (AST)_t;
				match(_t,Objekt);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					agg = ProcessingInformation.ApplyAggregation.GESAMT_OBJEKT;
				}
				break;
			}
			case Spalte:
			{
				AST tmp49_AST_in = (AST)_t;
				match(_t,Spalte);
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t287;
			_t = _t.getNextSibling();
			break;
		}
		case Intervall:
		{
			AST __t289 = _t;
			AST tmp50_AST_in = (AST)_t;
			match(_t,Intervall);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				agg = ProcessingInformation.ApplyAggregation.INTERVALL_SPALTE;
			}
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Objekt:
			{
				AST tmp51_AST_in = (AST)_t;
				match(_t,Objekt);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					agg = ProcessingInformation.ApplyAggregation.INTERVALL_OBJEKT;
				}
				break;
			}
			case Spalte:
			{
				AST tmp52_AST_in = (AST)_t;
				match(_t,Spalte);
				_t = _t.getNextSibling();
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t289;
			_t = _t.getNextSibling();
			break;
		}
		case Liste:
		{
			AST __t291 = _t;
			AST tmp53_AST_in = (AST)_t;
			match(_t,Liste);
			_t = _t.getFirstChild();
			{
			_loop293:
			do {
				if (_t==null) _t=ASTNULL;
				if (((_t.getType() >= Spalten && _t.getType() <= NichtAuffuellenB))) {
					AST tmp54_AST_in = (AST)_t;
					if ( _t==null ) throw new MismatchedTokenException();
					_t = _t.getNextSibling();
				}
				else {
					break _loop293;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				agg = ProcessingInformation.ApplyAggregation.LISTE;
			}
			_t = __t291;
			_t = _t.getNextSibling();
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return agg;
	}
	
	public final void standardsMitBlock(AST _t) throws RecognitionException {
		
		AST standardsMitBlock_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		{
		_loop300:
		do {
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Mit:
			{
				mitKonstruktObjekte(_t);
				_t = _retTree;
				break;
			}
			case Name:
			{
				objektDefinition(_t);
				_t = _retTree;
				break;
			}
			case Pseudoobjekt:
			{
				pseudoObjektDefinition(_t);
				_t = _retTree;
				break;
			}
			case Protokollzeitraum:
			{
				protokollzeitraumDefinition(_t);
				_t = _retTree;
				break;
			}
			case Protokollart:
			{
				protokollartDefinition(_t);
				_t = _retTree;
				break;
			}
			case Fragezeichen:
			{
				standardbindungDefinition(_t);
				_t = _retTree;
				break;
			}
			case UnveraendertKennungA:
			case UnveraendertKennungB:
			{
				unveraendertKennungDefinition(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				break _loop300;
			}
			}
		} while (true);
		}
		_retTree = _t;
	}
	
	public final void mitKonstruktObjekte(AST _t) throws RecognitionException {
		
		AST mitKonstruktObjekte_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST P = null;
		
				List<String> path = null;
			
		
		AST __t302 = _t;
		AST tmp55_AST_in = (AST)_t;
		match(_t,Mit);
		_t = _t.getFirstChild();
		P = _t==ASTNULL ? null : (AST)_t;
		path=qualifizierung(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.push(P, path);
		}
		standardsMitBlock(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.pop();
		}
		_t = __t302;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void objektDefinition(AST _t) throws RecognitionException {
		
		AST objektDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t304 = _t;
		AST tmp56_AST_in = (AST)_t;
		match(_t,Name);
		_t = _t.getFirstChild();
		{
		_loop306:
		do {
			if (_t==null) _t=ASTNULL;
			if ((_t.getType()==Name)) {
				AST tmp57_AST_in = (AST)_t;
				match(_t,Name);
				_t = _t.getNextSibling();
			}
			else {
				break _loop306;
			}
			
		} while (true);
		}
		_t = __t304;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void pseudoObjektDefinition(AST _t) throws RecognitionException {
		
		AST pseudoObjektDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t320 = _t;
		AST tmp58_AST_in = (AST)_t;
		match(_t,Pseudoobjekt);
		_t = _t.getFirstChild();
		{
		int _cnt322=0;
		_loop322:
		do {
			if (_t==null) _t=ASTNULL;
			if (((_t.getType() >= Spalten && _t.getType() <= NichtAuffuellenB))) {
				AST tmp59_AST_in = (AST)_t;
				if ( _t==null ) throw new MismatchedTokenException();
				_t = _t.getNextSibling();
			}
			else {
				if ( _cnt322>=1 ) { break _loop322; } else {throw new NoViableAltException(_t);}
			}
			
			_cnt322++;
		} while (true);
		}
		_t = __t320;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void protokollzeitraumDefinition(AST _t) throws RecognitionException {
		
		AST protokollzeitraumDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t308 = _t;
		AST tmp60_AST_in = (AST)_t;
		match(_t,Protokollzeitraum);
		_t = _t.getFirstChild();
		AST tmp61_AST_in = (AST)_t;
		match(_t,Datum);
		_t = _t.getNextSibling();
		AST tmp62_AST_in = (AST)_t;
		match(_t,Zeit);
		_t = _t.getNextSibling();
		AST tmp63_AST_in = (AST)_t;
		match(_t,Datum);
		_t = _t.getNextSibling();
		AST tmp64_AST_in = (AST)_t;
		match(_t,Zeit);
		_t = _t.getNextSibling();
		_t = __t308;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void protokollartDefinition(AST _t) throws RecognitionException {
		
		AST protokollartDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t310 = _t;
		AST tmp65_AST_in = (AST)_t;
		match(_t,Protokollart);
		_t = _t.getFirstChild();
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Aenderungsprotokoll:
		{
			AST tmp66_AST_in = (AST)_t;
			match(_t,Aenderungsprotokoll);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setProtocolType(ProtocolType.DeltaProtocol);
			}
			break;
		}
		case AenderungsprotokollUml:
		{
			AST tmp67_AST_in = (AST)_t;
			match(_t,AenderungsprotokollUml);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setProtocolType(ProtocolType.DeltaProtocol);
			}
			break;
		}
		case Zustandsprotokoll:
		{
			AST tmp68_AST_in = (AST)_t;
			match(_t,Zustandsprotokoll);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setProtocolType(ProtocolType.StatusProtocol);
			}
			break;
		}
		case Ereignisprotokoll:
		{
			AST tmp69_AST_in = (AST)_t;
			match(_t,Ereignisprotokoll);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				_miscSemantics.setProtocolType(ProtocolType.EventProtocol);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		_t = __t310;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void standardbindungDefinition(AST _t) throws RecognitionException {
		
		AST standardbindungDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t318 = _t;
		AST tmp70_AST_in = (AST)_t;
		match(_t,Fragezeichen);
		_t = _t.getFirstChild();
		AST tmp71_AST_in = (AST)_t;
		match(_t,GanzZahl);
		_t = _t.getNextSibling();
		AST tmp72_AST_in = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		_t = __t318;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void unveraendertKennungDefinition(AST _t) throws RecognitionException {
		
		AST unveraendertKennungDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case UnveraendertKennungA:
		{
			AST __t313 = _t;
			AST tmp73_AST_in = (AST)_t;
			match(_t,UnveraendertKennungA);
			_t = _t.getFirstChild();
			AST tmp74_AST_in = (AST)_t;
			match(_t,Pro);
			_t = _t.getNextSibling();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Zeile:
			{
				AST tmp75_AST_in = (AST)_t;
				match(_t,Zeile);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					_miscSemantics.setNoChangeMarker(NoChangeMarker.Row);
				}
				break;
			}
			case Zelle:
			{
				AST tmp76_AST_in = (AST)_t;
				match(_t,Zelle);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					_miscSemantics.setNoChangeMarker(NoChangeMarker.Cell);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t313;
			_t = _t.getNextSibling();
			break;
		}
		case UnveraendertKennungB:
		{
			AST __t315 = _t;
			AST tmp77_AST_in = (AST)_t;
			match(_t,UnveraendertKennungB);
			_t = _t.getFirstChild();
			AST tmp78_AST_in = (AST)_t;
			match(_t,Pro);
			_t = _t.getNextSibling();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Zeile:
			{
				AST tmp79_AST_in = (AST)_t;
				match(_t,Zeile);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					_miscSemantics.setNoChangeMarker(NoChangeMarker.Row);
				}
				break;
			}
			case Zelle:
			{
				AST tmp80_AST_in = (AST)_t;
				match(_t,Zelle);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					_miscSemantics.setNoChangeMarker(NoChangeMarker.Cell);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t315;
			_t = _t.getNextSibling();
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
	}
	
	public final void definitionenMitBlock(AST _t) throws RecognitionException {
		
		AST definitionenMitBlock_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		{
		_loop327:
		do {
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Mit:
			{
				mitKonstruktDefinitionen(_t);
				_t = _retTree;
				break;
			}
			case TempAttribut:
			{
				tempAttributDefinition(_t);
				_t = _retTree;
				break;
			}
			case Aggregationsfunktion:
			{
				aggregatsfunktionDefinition(_t);
				_t = _retTree;
				break;
			}
			case Alias:
			{
				aliasDefinition(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				break _loop327;
			}
			}
		} while (true);
		}
		_retTree = _t;
	}
	
	public final void mitKonstruktDefinitionen(AST _t) throws RecognitionException {
		
		AST mitKonstruktDefinitionen_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST P = null;
		
				List<String> path = null;
			
		
		AST __t329 = _t;
		AST tmp81_AST_in = (AST)_t;
		match(_t,Mit);
		_t = _t.getFirstChild();
		P = _t==ASTNULL ? null : (AST)_t;
		path=qualifizierung(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.push(P, path);
		}
		definitionenMitBlock(_t);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			_scopeSemantics.pop();
		}
		_t = __t329;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void tempAttributDefinition(AST _t) throws RecognitionException {
		
		AST tempAttributDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST n = null;
		AST t = null;
		
				ExpressionTree tree = null;
			
		
		AST __t331 = _t;
		AST tmp82_AST_in = (AST)_t;
		match(_t,TempAttribut);
		_t = _t.getFirstChild();
		n = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		t = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		tree=ausdruck(_t,true);
		_t = _retTree;
		_t = __t331;
		_t = _t.getNextSibling();
		if ( inputState.guessing==0 ) {
			_tempAttributeSemantics.addTempAttributeDefinition(n, n.getText(),t.getText(),tree);
		}
		_retTree = _t;
	}
	
	public final void aggregatsfunktionDefinition(AST _t) throws RecognitionException {
		
		AST aggregatsfunktionDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t333 = _t;
		AST tmp83_AST_in = (AST)_t;
		match(_t,Aggregationsfunktion);
		_t = _t.getFirstChild();
		AST tmp84_AST_in = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		AST tmp85_AST_in = (AST)_t;
		match(_t,Zeichenkette);
		_t = _t.getNextSibling();
		_t = __t333;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final void aliasDefinition(AST _t) throws RecognitionException {
		
		AST aliasDefinition_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		AST __t335 = _t;
		AST tmp86_AST_in = (AST)_t;
		match(_t,Alias);
		_t = _t.getFirstChild();
		AST tmp87_AST_in = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		AST tmp88_AST_in = (AST)_t;
		match(_t,Name);
		_t = _t.getNextSibling();
		_t = __t335;
		_t = _t.getNextSibling();
		_retTree = _t;
	}
	
	public final ExpressionLeaf  erweiterterAusdruck(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST erweiterterAusdruck_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Name:
		case NameMitKlammern:
		case Fragezeichen:
		case GanzZahl:
		case Zeitdauer:
		case Zeichenkette:
		case KommaZahl:
		case Falsch:
		case Wahr:
		case NichtAuffuellenA:
		case NichtAuffuellenB:
		{
			leaf=basisAusdruck(_t,b);
			_t = _retTree;
			break;
		}
		case EckigeKlammerAuf:
		case Potenz:
		case Exp:
		case Ln:
		case Min:
		case Max:
		case Abs:
		case IstFehler:
		case IstZahl:
		case IstZustand:
		case IstLeer:
		case IstText:
		case IstWahrheitswert:
		{
			leaf=erweiterbarerBasisAusdruck(_t,b);
			_t = _retTree;
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return leaf;
	}
	
	public final ExpressionLeaf  basisAusdruck(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST basisAusdruck_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST z = null;
		AST x = null;
		AST s = null;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case GanzZahl:
		{
			z = (AST)_t;
			match(_t,GanzZahl);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = ExpressionLeaf.createLongLeaf(z, z.getText());
			}
			break;
		}
		case KommaZahl:
		{
			x = (AST)_t;
			match(_t,KommaZahl);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = ExpressionLeaf.createDoubleLeaf(x, x.getText());
			}
			break;
		}
		case Falsch:
		case Wahr:
		{
			leaf=wahrheitswert(_t);
			_t = _retTree;
			break;
		}
		case Zeichenkette:
		{
			s = (AST)_t;
			match(_t,Zeichenkette);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf(s.getText().substring(1,s.getText().length()-1));
			}
			break;
		}
		case Name:
		case NameMitKlammern:
		case Fragezeichen:
		case NichtAuffuellenA:
		case NichtAuffuellenB:
		{
			leaf=attribut(_t,b);
			_t = _retTree;
			break;
		}
		case Zeitdauer:
		{
			AST tmp89_AST_in = (AST)_t;
			match(_t,Zeitdauer);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf(DurationAttributeDescription.forHash());
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return leaf;
	}
	
	public final ExpressionLeaf  erweiterbarerBasisAusdruck(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST erweiterbarerBasisAusdruck_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Potenz:
		case Exp:
		case Ln:
		case Min:
		case Max:
		case Abs:
		case IstFehler:
		case IstZahl:
		case IstZustand:
		case IstLeer:
		case IstText:
		case IstWahrheitswert:
		{
			leaf=funktionsAufruf(_t,b);
			_t = _retTree;
			break;
		}
		case EckigeKlammerAuf:
		{
			AST __t374 = _t;
			AST tmp90_AST_in = (AST)_t;
			match(_t,EckigeKlammerAuf);
			_t = _t.getFirstChild();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case Name:
			case NameMitKlammern:
			case Fragezeichen:
			case GanzZahl:
			case Zeitdauer:
			case Zeichenkette:
			case Minus:
			case Gleich:
			case Oder:
			case Und:
			case Ungleich:
			case Kleiner:
			case Groesser:
			case KleinerGleich:
			case GroesserGleich:
			case Plus:
			case Ampersand:
			case Mal:
			case Dividiert:
			case Div:
			case Modulo:
			case Nicht:
			case KommaZahl:
			case EckigeKlammerAuf:
			case Potenz:
			case Exp:
			case Ln:
			case Min:
			case Max:
			case Abs:
			case IstFehler:
			case IstZahl:
			case IstZustand:
			case IstLeer:
			case IstText:
			case IstWahrheitswert:
			case Falsch:
			case Wahr:
			case NichtAuffuellenA:
			case NichtAuffuellenB:
			{
				ausdruck(_t,b);
				_t = _retTree;
				{
				_loop377:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_0.member(_t.getType()))) {
						ausdruck(_t,b);
						_t = _retTree;
					}
					else {
						break _loop377;
					}
					
				} while (true);
				}
				break;
			}
			case 3:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			_t = __t374;
			_t = _t.getNextSibling();
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return leaf;
	}
	
	public final ExpressionLeaf  wahrheitswert(AST _t) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST wahrheitswert_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Falsch:
		{
			AST tmp91_AST_in = (AST)_t;
			match(_t,Falsch);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf(false);
			}
			break;
		}
		case Wahr:
		{
			AST tmp92_AST_in = (AST)_t;
			match(_t,Wahr);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf(true);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return leaf;
	}
	
	public final ExpressionLeaf  attribut(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST attribut_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST nichtAuffuellen = null;
		AST ast = null;
		
				ArrayList<String> v = new ArrayList<String>();
			
		
		{
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case NichtAuffuellenA:
		case NichtAuffuellenB:
		{
			nichtAuffuellen = _t==ASTNULL ? null : (AST)_t;
			nichtAuffuellen(_t);
			_t = _retTree;
			break;
		}
		case Name:
		case NameMitKlammern:
		case Fragezeichen:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		}
		ast = _t==ASTNULL ? null : (AST)_t;
		attributAngabe(_t,v);
		_t = _retTree;
		if ( inputState.guessing==0 ) {
			leaf = new ExpressionLeaf(_expressionSemantics.createExpressionAttribute(ast, v, b, nichtAuffuellen));
		}
		_retTree = _t;
		return leaf;
	}
	
	public final ExpressionLeaf  funktionsAufruf(AST _t,
		boolean b
	) throws RecognitionException {
		ExpressionLeaf leaf = null;
		
		AST funktionsAufruf_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		
				ArrayList<ExpressionTree> list = new ArrayList<ExpressionTree>();
				ExpressionTree x = null;
				ExpressionTree y = null;
			
		
		if (_t==null) _t=ASTNULL;
		switch ( _t.getType()) {
		case Potenz:
		{
			AST __t379 = _t;
			AST tmp93_AST_in = (AST)_t;
			match(_t,Potenz);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			y=ausdruck(_t,b);
			_t = _retTree;
			_t = __t379;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); list.add(y); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Power", list);
			}
			break;
		}
		case Exp:
		{
			AST __t380 = _t;
			AST tmp94_AST_in = (AST)_t;
			match(_t,Exp);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t380;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Exp", list);
			}
			break;
		}
		case Ln:
		{
			AST __t381 = _t;
			AST tmp95_AST_in = (AST)_t;
			match(_t,Ln);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t381;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Ln", list);
			}
			break;
		}
		case Min:
		{
			AST __t382 = _t;
			AST tmp96_AST_in = (AST)_t;
			match(_t,Min);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			if ( inputState.guessing==0 ) {
				list.add(x);
			}
			{
			int _cnt384=0;
			_loop384:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					y=ausdruck(_t,b);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						list.add(y);
					}
				}
				else {
					if ( _cnt384>=1 ) { break _loop384; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt384++;
			} while (true);
			}
			_t = __t382;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Min", list);
			}
			break;
		}
		case Max:
		{
			AST __t385 = _t;
			AST tmp97_AST_in = (AST)_t;
			match(_t,Max);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			if ( inputState.guessing==0 ) {
				list.add(x);
			}
			{
			int _cnt387=0;
			_loop387:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					y=ausdruck(_t,b);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						list.add(y);
					}
				}
				else {
					if ( _cnt387>=1 ) { break _loop387; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt387++;
			} while (true);
			}
			_t = __t385;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Max", list);
			}
			break;
		}
		case Abs:
		{
			AST __t388 = _t;
			AST tmp98_AST_in = (AST)_t;
			match(_t,Abs);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t388;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.Abs", list);
			}
			break;
		}
		case IstFehler:
		{
			AST __t389 = _t;
			AST tmp99_AST_in = (AST)_t;
			match(_t,IstFehler);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t389;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsError", list);
			}
			break;
		}
		case IstLeer:
		{
			AST __t390 = _t;
			AST tmp100_AST_in = (AST)_t;
			match(_t,IstLeer);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t390;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsEmpty", list);
			}
			break;
		}
		case IstText:
		{
			AST __t391 = _t;
			AST tmp101_AST_in = (AST)_t;
			match(_t,IstText);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t391;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsText", list);
			}
			break;
		}
		case IstWahrheitswert:
		{
			AST __t392 = _t;
			AST tmp102_AST_in = (AST)_t;
			match(_t,IstWahrheitswert);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t392;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsBoolean", list);
			}
			break;
		}
		case IstZahl:
		{
			AST __t393 = _t;
			AST tmp103_AST_in = (AST)_t;
			match(_t,IstZahl);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t393;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsNumber", list);
			}
			break;
		}
		case IstZustand:
		{
			AST __t394 = _t;
			AST tmp104_AST_in = (AST)_t;
			match(_t,IstZustand);
			_t = _t.getFirstChild();
			x=ausdruck(_t,b);
			_t = _retTree;
			_t = __t394;
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				list.add(x); leaf = new ExpressionLeaf("de.bsvrz.pua.prot.functions.IsState", list);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(_t);
		}
		}
		_retTree = _t;
		return leaf;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"Spalten",
		"Doppelpunkt",
		"Mit",
		"Ende",
		"Name",
		"NameMitKlammern",
		"Fragezeichen",
		"GanzZahl",
		"Attribut",
		"Zeitdauer",
		"Als",
		"Zeichenkette",
		"TempAttribut",
		"Attributgruppe",
		"Filter",
		"Aggregation",
		"Komma",
		"Einschraenkung",
		"EinschraenkungUml",
		"Verschmelzen",
		"Anwendung",
		"Gesamt",
		"KlammerAuf",
		"Objekt",
		"Spalte",
		"KlammerZu",
		"Intervall",
		"Liste",
		"Nachfilter",
		"Standards",
		"Protokollzeitraum",
		"Datum",
		"Zeit",
		"Minus",
		"Protokollart",
		"Aenderungsprotokoll",
		"AenderungsprotokollUml",
		"Zustandsprotokoll",
		"Ereignisprotokoll",
		"Gleich",
		"UnveraendertKennungA",
		"Pro",
		"Zeile",
		"Zelle",
		"UnveraendertKennungB",
		"Pseudoobjekt",
		"Definitionen",
		"Aggregationsfunktion",
		"Alias",
		"Oder",
		"Und",
		"Ungleich",
		"Kleiner",
		"Groesser",
		"KleinerGleich",
		"GroesserGleich",
		"Plus",
		"Ampersand",
		"Mal",
		"Dividiert",
		"Div",
		"Modulo",
		"Nicht",
		"KommaZahl",
		"EckigeKlammerAuf",
		"EckigeKlammerZu",
		"Potenz",
		"Exp",
		"Ln",
		"Min",
		"Max",
		"Abs",
		"IstFehler",
		"IstZahl",
		"IstZustand",
		"IstLeer",
		"IstText",
		"IstWahrheitswert",
		"Falsch",
		"Wahr",
		"NichtAuffuellenA",
		"NichtAuffuellenB"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { -8998265722720512L, 4194271L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	}
	
