/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.pua.prot.processing.onlinebuffer;

import de.bsvrz.sys.funclib.losb.datk.ProtocolType;
import de.bsvrz.pua.prot.util.attributes.AttributeGroupDescription;
import de.bsvrz.sys.funclib.losb.exceptions.FailureException;

/**
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $Revision$ / $Date$ / ($Author$)
 */
public class RealOnlineAttributeGroup extends RealOnlineElement {

	/**
	 * Erzeugt das Objekt. Ruft {@link RealOnlineElement#setReceiver(OnlineDataReceiver)} auf.
	 *
	 * @param receiverSet   Objekt das die Anmeldung auf die DAV-Daten durchführt.
	 * @param atg           Attributgruppenbeschreibung
	 * @param protocolType  Protokollart
	 * @param isShown       Wird das Element im Spalten-Bereich verwendet? <code>true</code>Element wird im Spalten Bereich verwendet.
	 *
	 * @throws FailureException Fehler bei der Kommunikation mit der Konfiguration.
	 */
	public RealOnlineAttributeGroup(OnlineDataReceiverSet receiverSet, AttributeGroupDescription atg, ProtocolType protocolType, boolean isShown)
			throws FailureException {
		super(receiverSet, protocolType, isShown, atg.padData());
		setReceiver(receiverSet.createReceiver(atg.getReferenceQualifier()));
	}
}
